#ifndef GAMES_GMSBASE_H
#define GAMES_GMSBASE_H
/*
**	$VER: gamesbase.h 0.1 (27.5.96)
**	Includes Release xx.xx
**
**	Definition of the games.library base structure.
**
**	(C) Copyright 1996 DreamWorld Productions.
**	    All Rights Reserved
*/

#ifndef EXEC_TYPES_H
#include "exec/types.h"
#endif
#ifndef EXEC_LISTS_H
#include <exec/lists.h>
#endif
#ifndef EXEC_LIBRARIES_H
#include <exec/libraries.h>
#endif

 struct	GMSBase
  {
  struct Library LibNode;         /* Standard library stuff */
  
  ULONG  RandomSeed;              /* Random seed */
  UWORD  SYS_CPU;                 /* '000, '010, '020, '030, '040, '060 */
  
  WORD   OldMouseX1;              /* Private */
  WORD   OldMouseY1;              /* Private */
  WORD   OldMouseX2;              /* Private */
  WORD   OldMouseY2;              /* Private */
  WORD   MouseX1;                 /* Current mouse position X (port 1) */
  WORD   MouseY1;                 /* Current mouse position Y (port 1) */
  WORD   MouseX2;                 /* Current mouse position X (port 2) */
  WORD   MouseY2;                 /* Current mouse position Y (port 2) */

  UWORD  MouseButtons1;
  UWORD  MouseButtons2;

  UWORD  MX_AreaWidth;            /* Mouse - maximum X position */
  UWORD  MY_AreaHeight;           /* Mouse - maximum Y position */
  
  UWORD  VBL_Position;            /* VBL Position (End of Screen mark) */
  APTR   CurrentScreen;           /* Ptr to currently displayed screen */
  
  UWORD  BlitterUsed;             /* 0 = Free, 1 = Grabbed */
  
  APTR   PRF_JoyEmuKeys;
  APTR   PRF_CallingList;
  
  APTR   PRF_ScreensFile;         /* Location of the file (offset from */
  APTR   PRF_BlitterFile;         /* the start of the prefs file) */
  APTR   PRF_SoundFile;
  APTR   PRF_NetworkFile;
  APTR   PRF_VectorsFile;
  APTR   PRF_C2PFile;
  
  APTR   PRF_MusicRD1;
  APTR   PRF_MusicRD2;
  APTR   PRF_MusicRD3;
  APTR   PRF_MusicRD4;
  APTR   PRF_MusicRD5;
  APTR   PRF_MusicRD6;
  APTR   PRF_MusicRD7;
  APTR   PRF_MusicRD8;
  
  UBYTE  PRF_AmigaChipSet;        /* OCS/ECS/AGA */
  UBYTE  PRF_ModePromote;         /* Promotion of the monitor sync */
  UBYTE  PRF_GfxBoard;            /* GfxBoard, if any */
  UWORD  PRF_JoyType1;            /* Type of Joystick in port 1 */
  UWORD  PRF_JoyType2;            /* Type of Joystick in port 2 */
  UBYTE  PRF_JoyEmulation;        /* Joystick emulation on/off */
  UBYTE  PRF_UserPri;             /* User priority */
  UBYTE  PRF_VectorDetail;        /* Level of vector detail */
  UBYTE  PRF_Music;               /* Music on or off? */
  UBYTE  PRF_Sound;               /* Sound on or off? */
  UBYTE  PRF_Network;             /* Type of networking to use */
  UBYTE  PRF_Reserved;
  UWORD  PRF_TopOfScrX;           /* Top of Screen X */
  UWORD  PRF_TopOfScrY;           /* Top of Screen Y */
  };

#define GMSNAME "games.library"

#endif /* GAMES_GMSBASE_H */

