#ifndef AROS_CONFIG_SASC_ABSCALL_H
#define AROS_CONFIG_SASC_ABSCALL_H
/* (C) 1995 AROS - The Amiga Replacement OS */

/******************************************************************************

    MODUL
	$Id$

    DESCRIPTION
	This is the config file for abscalls for SAS/C. Read
	aros/abscall.h for details.

	This file declares the actual LH<x><y> macros where
	<x> is the number of parameters and <y> are flags.

******************************************************************************/

/* Includes */
#ifndef AROS_LIBCALL_H
#   include <aros/libcall.h>
#endif

/*
    Another macro:

    __AROS_AC_HEADER(t,fp,pd,p)

    t:	Return type
    fp: Pointer to function
    pd: Parameter-list (types only)
    p:	Parameter-list (types and names)
*/
#define __AROS_AC_HEADER(t,fp,pd,p) \
	((t (* __asm)pd) fp) p

/*
    Macros to extract parts of the arguments.

    __AROS_ACA() expands to its arguments
    __AROS_ACAET() expands to the type if the parameter only (including
	    the CPU register if neccessary)
    __AROS_ACAEP() expands to the name of the parameter only

    __AROS_ACA(int,a,D0)   -> int,a,D0
    __AROS_ACAET(int,a,D0) -> D0 int
    __AROS_ACAEP(int,a,D0) -> a
*/
#define __AROS_ACA(t,p,r)      t,p,r
#define __AROS_ACAET(t,p,r)     r t
#define __AROS_ACAEP(t,p,r)     p

#define __AROS_AC0(t,fp) \
    __AROS_AC_HEADER(t,fp,(),());

#define __AROS_AC1(t,fp,a1) \
    __AROS_AC_HEADER(t,fp,\
    (__AROS_ACAET(a1)),\
    (__AROS_ACAEP(a1)))

#define __AROS_AC2(t,fp,a1,a2) \
    __AROS_AC_HEADER(t,fp,\
    (__AROS_ACAET(a1),__AROS_ACAET(a2)),\
    (__AROS_ACAEP(a1),__AROS_ACAEP(a2)))

#define __AROS_AC3(t,fp,a1,a2,a3) \
    __AROS_AC_HEADER(t,fp,\
    (__AROS_ACAET(a1),__AROS_ACAET(a2),__AROS_ACAET(a3)),\
    (__AROS_ACAEP(a1),__AROS_ACAEP(a2),__AROS_ACAEP(a3)))

#define __AROS_AC4(t,fp,a1,a2,a3,a4) \
    __AROS_AC_HEADER(t,fp,\
    (__AROS_ACAET(a1),__AROS_ACAET(a2),__AROS_ACAET(a3),\
	__AROS_ACAET(a4)),\
    (__AROS_ACAEP(a1),__AROS_ACAEP(a2),__AROS_ACAEP(a3),\
	__AROS_ACAEP(a4)))

#define __AROS_AC5(t,fp,a1,a2,a3,a4,a5) \
    __AROS_AC_HEADER(t,fp,\
    (__AROS_ACAET(a1),__AROS_ACAET(a2),__AROS_ACAET(a3),\
	__AROS_ACAET(a4),__AROS_ACAET(a5)),\
    (__AROS_ACAEP(a1),__AROS_ACAEP(a2),__AROS_ACAEP(a3),\
	__AROS_ACAEP(a4),__AROS_ACAEP(a5)))

#define __AROS_AC6(t,fp,a1,a2,a3,a4,a5,a6) \
    __AROS_AC_HEADER(t,fp,\
    (__AROS_ACAET(a1),__AROS_ACAET(a2),__AROS_ACAET(a3),\
	__AROS_ACAET(a4),__AROS_ACAET(a5),__AROS_ACAET(a6)),\
    (__AROS_ACAEP(a1),__AROS_ACAEP(a2),__AROS_ACAEP(a3),\
	__AROS_ACAEP(a4),__AROS_ACAEP(a5),__AROS_ACAEP(a6)))

#define __AROS_AC7(t,fp,a1,a2,a3,a4,a5,a6,a7) \
    __AROS_AC_HEADER(t,fp,\
    (__AROS_ACAET(a1),__AROS_ACAET(a2),__AROS_ACAET(a3),\
	__AROS_ACAET(a4),__AROS_ACAET(a5),__AROS_ACAET(a6),__AROS_ACAET(a7)),\
    (__AROS_ACAEP(a1),__AROS_ACAEP(a2),__AROS_ACAEP(a3),\
	__AROS_ACAEP(a4),__AROS_ACAEP(a5),__AROS_ACAEP(a6),__AROS_ACAEP(a7)))

#define __AROS_AC8(t,fp,a1,a2,a3,a4,a5,a6,a7,a8) \
    __AROS_AC_HEADER(t,fp,\
    (__AROS_ACAET(a1),__AROS_ACAET(a2),__AROS_ACAET(a3),\
	__AROS_ACAET(a4),__AROS_ACAET(a5),__AROS_ACAET(a6),__AROS_ACAET(a7),\
	__AROS_ACAET(a8)),\
    (__AROS_ACAEP(a1),__AROS_ACAEP(a2),__AROS_ACAEP(a3),\
	__AROS_ACAEP(a4),__AROS_ACAEP(a5),__AROS_ACAEP(a6),__AROS_ACAEP(a7),\
	__AROS_ACAEP(a8)))

#define __AROS_AC9(t,fp,a1,a2,a3,a4,a5,a6,a7,a8,a9) \
    __AROS_AC_HEADER(t,fp,\
    (__AROS_ACAET(a1),__AROS_ACAET(a2),__AROS_ACAET(a3),\
	__AROS_ACAET(a4),__AROS_ACAET(a5),__AROS_ACAET(a6),__AROS_ACAET(a7),\
	__AROS_ACAET(a8),__AROS_ACAET(a9)),\
    (__AROS_ACAEP(a1),__AROS_ACAEP(a2),__AROS_ACAEP(a3),\
	__AROS_ACAEP(a4),__AROS_ACAEP(a5),__AROS_ACAEP(a6),__AROS_ACAEP(a7),\
	__AROS_ACAEP(a8),__AROS_ACAEP(a9)))

#define __AROS_AC10(t,fp,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10, bt,bn,o,m) \
    __AROS_AC_HEADER(t,fp,\
    (__AROS_ACAET(a1),__AROS_ACAET(a2),__AROS_ACAET(a3),\
	__AROS_ACAET(a4),__AROS_ACAET(a5),__AROS_ACAET(a6),__AROS_ACAET(a7),\
	__AROS_ACAET(a8),__AROS_ACAET(a9),__AROS_ACAET(a10)),\
    (__AROS_ACAEP(a1),__AROS_ACAEP(a2),__AROS_ACAEP(a3),\
	__AROS_ACAEP(a4),__AROS_ACAEP(a5),__AROS_ACAEP(a6),__AROS_ACAEP(a7),\
	__AROS_ACAEP(a8),__AROS_ACAEP(a9),__AROS_ACAEP(a10))

#define __AROS_AC11(t,fp,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11) \
    __AROS_AC_HEADER(t,fp,\
    (__AROS_ACAET(a1),__AROS_ACAET(a2),__AROS_ACAET(a3),\
	__AROS_ACAET(a4),__AROS_ACAET(a5),__AROS_ACAET(a6),__AROS_ACAET(a7),\
	__AROS_ACAET(a8),__AROS_ACAET(a9),__AROS_ACAET(a10),__AROS_ACAET(a11)),\
    (__AROS_ACAEP(a1),__AROS_ACAEP(a2),__AROS_ACAEP(a3),\
	__AROS_ACAEP(a4),__AROS_ACAEP(a5),__AROS_ACAEP(a6),__AROS_ACAEP(a7),\
	__AROS_ACAEP(a8),__AROS_ACAEP(a9),__AROS_ACAEP(a10),__AROS_ACAEP(a11)))

/******************************************************************************
*****  ENDE aros/config/sasc/abscall.h
******************************************************************************/

#endif /* AROS_CONFIG_SASC_ABSCALL_H */
