/*
    (C) 1995 AROS - The Amiga Replacement OS
    $Id: remmemhandler.c 1.1 1995/11/14 22:31:07 digulla Exp digulla $
    $Log: remmemhandler.c $
 * Revision 1.1  1995/11/14  22:31:07  digulla
 * Initial revision
 *
    Desc:
    Lang: english
*/
#include "exec_intern.h"

/*****************************************************************************

    NAME */
	#include <exec/interrupts.h>
	#include <clib/exec_protos.h>

	__AROS_LH1(void, RemMemHandler,

/*  SYNOPSIS */
	__AROS_LA(struct Interrupt *, memhand, A1),

/*  LOCATION */
	struct ExecBase *, SysBase, 130, Exec)

/*  FUNCTION
	Remove some function added with AddMemHandler again.

    INPUTS
	memHandler - The same Interrupt structure you gave to AddMemHandler().

    RESULT

    NOTES

    EXAMPLE

    BUGS

    SEE ALSO
	AddMemHandler()

    INTERNALS

    HISTORY
	18-10-95    created by m. fleischer
	26-10-95    digulla adjusted to new calling scheme

******************************************************************************/
{
    __AROS_FUNC_INIT

    /* Protect the low memory handler list */
    Forbid();

    /* Nothing spectacular: Just remove node */
    Remove(&memhand->is_Node);

    Permit();
    __AROS_FUNC_EXIT
} /* RemMemHandler */

